

//*** CONTROLANDO LA BUSQUEDA

#ifdef CLEAR_HASH    
int        fase_actual = 5;
int        fase_anterior = 5;
#endif	
int        Abandonar = 0;

void computer_mov(void)
{
   int alpha,beta;
   int Root_eval,BestEval;
   int i,j;
   int movlegal  = 0;
   //int eval_iter[64];
   bool Root_Jaque;
   bool mov_facil = true;
   tipojugada tmp; 

   stop_search = false;
   start_time = GetTime();
   stop_time = start_time + maxtiempo;

//** Si la configuracion del tablero ha cambiado significativamente,
//** refrescamos las hash, para evitar interferencias.
#ifdef CLEAR_HASH    
   fase_anterior = fase_actual;
	if(FichasBB + FichasNN == 0 &&
       PeonesBB + PeonesNN > 0){
		   if(PeonesBB + PeonesNN == 1) fase_actual = 0;
		   else fase_actual = 1;
	}
	else if(MaterialBB == 0 || MaterialNN == 0)
		 fase_actual = 2;
	else if(PeonesBB + PeonesNN == 0) fase_actual = 3;
	else if(FichasBB == 1 && FichasNN == 1) fase_actual = 4;	
	else fase_actual = 5; 

	if(fase_anterior != fase_actual) clear_hash();
#endif	

   //Nodo_mov_nulo = false;
   Profundidad = 0; 
   memset (matekiller, 0, sizeof(matekiller));
   memset (killer1, 0, sizeof(killer1));
   memset (killer2, 0, sizeof(killer2));
   memset (good_mov, 0, sizeof(good_mov));
   max_good_mov = 0;

//** Generamos todos los movimientos
	genera_todo();

//** Comprobamos si hay algun movimiento legal, y de
//** paso asignamos un valor, a cada jugada utilizando
//** Qsearch(), y luego las ordenamos de mejor a peor.

for(i = 0; i < PilaMax[1]; i++) {
	 MakeMove(i);
     if(es_legal()) {
		 movlegal++;
	// De momento desactivado, hacer un qsearch() especial ??
	// ListaMov[i].eval = -qsearch(-VALMATE,VALMATE, 2); 
	 }
	 else ListaMov[i].eval = -VALMATE;
     retrocede(); 	
}

//ordenamos los movimientos
for(i = 0; i < PilaMax[1]; i++) {
	for (j = 0 ; j < i; j++){	
		if (ListaMov[i].eval > ListaMov[j].eval){
			tmp = ListaMov[j];
			ListaMov[j] = ListaMov[i];
			ListaMov[i] = tmp;
		}
	}
}

/*
if(!wboard){
printf("\n  "); 
for(i = 0; i < PilaMax[1]; i++) {
 muestra_mov(i);
 printf("  mov %2d =  %4d \n  ",i,ListaMov[i].eval); 
}

printf("\nPly   Crono  Eval  Nodos/s     Variante principal\n"); 
printf("\***********************************************************************\n"); 
}

*/

//** Comprobamos que no sea una posicion de tablas o mate
if(movlegal == 0){
//** Comprobamos si estamos en jaque
	if(Color == BLANCAS)
	     Root_Jaque = casilla_atacada(Pos_RB,NEGRAS);
	else Root_Jaque = casilla_atacada(Pos_RN,BLANCAS);

	if(!Root_Jaque){
		if(wboard)  printf("1/2-1/2 {Stalemate}\n");
		else  printf("\n TABLAS AHOGADO!!...\n");
			return;
	}
	else if(!wboard) printf("\n MATE!!...\n");
	return;		 
}

//** else comprobar si son tablas por repeticion o regla 50 mov

//*********** EMPEZAMOS LA BUSQUEDA EN EL ARBOL ***********

   Profundidad = 0; 
   nodos = qnodos = 0; 
   nul_probado = nul_exito = 0;
   TTProbes = TTHits = 0; 
   PosC = 0; PosL = 0;

  
   /** Este es el bucle principal del motor de bsqueda
   *** Empezamos con Ply 1 hasta Ply mximo y nos paramos cuando se acabe
   *** el tiempo o se pulse una tecla, 
   *** En cada Ply llamamos a search() con el parametro Ply, que se ira
   *** reduciendo en uno, en cada llamada recursiva a si misma,  */

   for(Ply = 1; Ply <= MAX_PLY; Ply++) {

 /*** Si estamos en el primer ply,entonces ponemos las ventana alpha-beta
  *** a +- infinito, para que quepa cualquier jugada.
  *** En cualquier otro ply restringimos las ventanas a los valores encon-
  *** trados en el ply anterior, +- (un valor entre 50 y 100.*/

      if(Ply==1) {
		alpha = -VALMATE;
		beta  =  VALMATE;
      }

      else {
		alpha = alpha - 100;
		beta  = alpha + 100;
		if(alpha < -VALMATE) alpha = -VALMATE;
		if(beta >   VALMATE) beta  =  VALMATE;
      }


	//** Comprobamos si tenemos que salir del bucle, if...
	
    // Si se nos acaba el tiempo 
      if(stop_search == true) break;
	 
    // Si hemos consumido la mitad del tiempo asignado no entramos
    // en otro ply, lo mas probable es que no podamos acabarlo.
      if ((GetTime() - start_time) >=  (maxtiempo * 60)/100
		  && !en_tiempo_contrario) break;

	// Si estamos pensando en tiempo del contrario
	  //if (en_tiempo_contrario && Ply >= 15) break;

	// Si solo tenemos un movimiento legal en esta posicion
	  if(movlegal == 1 && Ply >= 5) break;  

    // Si es una recaptura de Torre o Dama, y no se ha cambiado de
    // mejor movimiento, lo consideraremos un movimiento facil 
	  if(!Analiza && !en_tiempo_contrario &&
		  mov_facil && Ply > 10 && 
          ListaMov[0].capturada >= T_B &&
		 (historial[hply-1].capturada ==
		  ListaMov[0].capturada) &&
         (GetTime() - start_time)>= (maxtiempo/8)){
		 break;
	  } 
	

 
//** Bucle para ejecutar todos los mov disponibles, en este momento los
//** ejecutamos en el orden en que se generaron, excepto el mov de la VP, 
//** que siempre lo colocamos en primer lugar, asi sera el primero en la 
//** siguiente busqueda, y ademas lo tendremos disponible para ejecutarlo
//** cuando se requiera.

      for(i = 0; i < PilaMax[1]; i++) {

// Si se nos acaba el tiempo paramos de ver movimientos
     if(stop_search == true) break;
       
	 VarPrinc[Profundidad][Profundidad].origen = 0;
// En modo consola, mostramos el movimiento que estamos analizando
	 if(!wboard){
	 printf(" Ply (%2d)  Analizando..(%d) ",Ply,i+1);
	 muestra_mov(i);
	 printf(" \r  ");}

//* Si hemos visto mate nos salimos y ejecutamos el movimiento	
	 if(alpha >= VALMATE - 100 && Ply >= 5 ){
		 Ply = MAX_PLY;
		 break; 
	 }
	 
//* ejecutamos el movimiento y comprobamos que sea legal, seguro que al menos
//* hay un movimiento legal, de lo contrario, no estariamos aqui.
	 MakeMove(i);
     if(!es_legal()) {
         retrocede(); 	
         continue;
	 }

//** Tambien aprovechamos que estamos en la raiz, para poner la variable Var_
//** Principal a TRUE o FALSE, nos puede ser de mucha utilidad en search(). 
//** Recordemos que si el movimiento (i) = 0, quiere decir que es el primero 
//** de la lista, y por lo tanto es el primer movimiento de la VP.  
	 if(i == 0 )  Var_Principal = true;
	 else         Var_Principal = false;

//* Ponemos a trabajar el motor de busqueda, que se ira llamanso a si mismo
//* recursivamente, reduciendo Ply en 1, (Ply pasara a llamarse Depth dentro
//* de la rutina search) que podra reducirse aun mas, o incrementarse, segun
//* las necesidades de la posicion, hasta llegar a ser 0, entonces toma el
//* control otra rutina, (Qsearch(), que solo mirara los movimientos que sean
//* capturas, para finalmente devolvernos el valor de la posicion.

	 Root_eval = -search(-beta,-alpha,Ply-1,true,desconocido);

//* Retrocedemos el movimiento, y analizamos el valor que hemos recibido
	 retrocede();
	 
//* Primero miramos si se trata de la Variante Principal
	 if(i == 0) {
      
//* Si la ventana alpha se ha quedado pequea, la ensanchamos al maximo para
//* que quepa cualquier movimiento, y volvemos a analizar el mismo movimiento
//* pero con las ventanas alpha beta modificadas

	 if(Root_eval <= alpha) {  
	    alpha = -VALMATE;
	    beta  =  Root_eval;
	    MakeMove(i);
	    Root_eval = -search(-beta,-alpha,Ply-1,true,desconocido);
	    retrocede();
	 }
//* El mismo caso anterior pero ahora con la ventana beta
	 else if(Root_eval >= beta) {      
	    alpha = Root_eval;
	    beta  = VALMATE;
	    MakeMove(i);
	    Root_eval = -search(-beta,-alpha,Ply-1,true,desconocido);
	    retrocede();
	 }

//* Por el contrario, si las ventanas han funcionado bien, las reajustamos, 
//* actualizamos la lista de movimientos de la Variante Principal, con este
//* movimiento, y la mostramos en pantalla
	
		alpha = Root_eval;
	    beta  = alpha+1;
	    ActVarPrincipal(i);

		if (Ply >= 6) MuestraVarPrinc(Ply,Root_eval);
		

//* Si hemos visto mate nos salimos y ejecutamos el movimiento	
	if(alpha > VALMATE - 100 ) {
		Ply = MAX_PLY;
		break;
	}

	}//if(i==0)

//* No es el primer movimiento y por tanto tampoco la Var_Principal  
	 else { 
	    if(Root_eval > alpha) {
	       BestEval  = alpha; //tolerancia = alpha + 5, desactivada.
	       alpha     = Root_eval;
	       beta      = VALMATE;       
	       MakeMove(i);
	       Root_eval = -search(-beta,-alpha,Ply-1,true,desconocido);
	       retrocede();

	    if(Root_eval > BestEval) {  
		   alpha = Root_eval;
		   beta  = alpha+1;
		   ActVarPrincipal(i);
		   if (Ply >= 6) MuestraVarPrinc(Ply,Root_eval); 
      
//* Ponemos la mejor jugada en primer lugar (en ListaMov[0]),
//* haciendole sitio, desplazando el resto de movimientos.	

		 if( i != 0){
		  tmp = ListaMov[i];
		  for(j = i; j > 0; j--) {
             ListaMov[j] = ListaMov[j-1];
		  }
		  ListaMov[0] = tmp;
		  // Si cambiamos de movimiento, no lo consideramos 
		  // un movimiento facil
		  if (Ply >= 3) mov_facil = false;
		 }

	       }//if(eval > BestEval)
	    }//if(eval > alpha)
	 }//else no estamos en Var_Principal  
   }//for(i=0
   
 
 }//for(Ply=1;
 
 
//* Nos hemos salido del bucle Ply, bien porque hemos visto mate, porque se 
//* ha acabado el tiempo, porque solo habia un movimiento, o se ha pulsado
//* una tecla, analizamos el resultado e informamos por pantalla o a WB.

	  // Si estamos en modo WinBoard
	  if(wboard && !en_tiempo_contrario && !Analiza){

	        //* Si la posicion es desesperada, abandonamos
			if(Root_eval < -900){
				Abandonar++;
				if(Abandonar >= 3 &&
				   Crono_oponente > 20000 &&
				   FichasBB > 0 && PeonesBB > 0 &&
				   FichasNN > 0 && PeonesNN > 0){
					printf("resign \n"); 
					fflush(stdout);
				}
			}
			else Abandonar = 0;

	     muestra_mov(0); 
		 MakeMove(0);
		 // Si la posicion es de tablas, lo comunicamos,
		 if(repeticion() >= 2 ){
			 printf("1/2-1/2 {Draw by repetition}\n");	
			 Abandonar = 0;
		 }
		 else if(fifty >= 100){
			 printf("1/2-1/2 {Draw by 50 move rule}\n");	   
			 Abandonar = 0;
		 }

	     // Si ponderar = true, seguimos analizando
		  if(ponderar == true && Abandonar == 0){
             en_tiempo_contrario = true;
			 computer_mov();
		  }
	  }//wboard 

	  // Si estamos en modo consola
	  else if(!wboard){
          int crono = (GetTime()-start_time)/1000;
		  int totalnodos = nodos+qnodos;

		 printf("Mi jugada: ");
		 muestra_mov(0);
		 printf("                           \n ");
		 MakeMove(0);

		 printf("\n H-Almacenadas = %6d, H-probadas = %6d,   H-exito = %6d\n",
		      TTStores,TTProbes, TTHits);
		 printf(" nodos = %d, q-nodos = %d   total nodos = %d \n",
	          nodos,qnodos,totalnodos);
		 printf(" Evaluaciones cortas = %ld,  Evaluaciones completas = %ld\n",PosC,PosL); 
		 printf(" nulos probados = %d, nulos exitos = %d  \n",nul_probado,nul_exito);

		 if ((GetTime()-start_time)/1000 > 1) // para no dividir por cero
		 printf(" Crono = %ldseg, Pos/Seg = %d\n",crono,totalnodos/crono ); 

		 if(!modotest)
		 dibuja_tablero();

		 // Si henos visto mate, lo anunciamos en modo consola
		 if(alpha >= VALMATE - 30) {
		  if((VALMATE-2-alpha)/2 == 0) {
			  if(Color == NEGRAS)
			  printf ("\n blancas ganan JAQUE MATE   ");
			  else
			  printf ("\n negras ganan JAQUE MATE   ");
		  }
		  else printf("\n MATE en %d  ",(VALMATE-2-alpha)/2);
        } //alpha >= VALMATE - 30

	  }//modo consola
 
}//computer_mov 



//****************************************************************
//#define es_peon7(x) contenido[abs(x)]==P_B && (x>H6 || x<A3)
//int FutilityMoveCount1[15]  = {50,7,8,9,10,11,12,15,19,23,28,33,39,45,52}; //ori
//int FutilityMoveCount3[15]  = {50,5,6,7,8,9,12,15,18,21,24,27,31,35,40}; 
//int FutilityMoveCount[15]  = {50,5,6,7,8,9,10,11,12,13,14,15,16,17,18}; 

int val_mate_en(int ply) {
  return VALMATE - ply;
}

int val_matado_en(int ply) {
  return -VALMATE + ply;
}

bool valor_es_mate(int valor) {
    if( valor <= -VALMATE + 100 ||
        valor >=  VALMATE - 100)
		  return true;
	else  return false;
  }

int search(int alpha,int beta,int Depth,bool hacer_nulo,int check)
{
   int   eval,BestEval;
   int   valorhash, htipo;
   int   mov_legales,i;
   int   nodo_pv =  ((beta - alpha) > 1);
   bool  EnJaque      = false;
   bool  jaque        = false;
   bool  extendido    = false;
   bool  amenaza_mate = false;

#ifdef HACER_NULO    
    int R;
	int Vhply;
	int nmscore;
	int Valpaso;
	int v_nulo = 0;
	U64 Vhash;
#endif	

tipomov bestmove = nomove;
VarPrinc[Profundidad][Profundidad].origen=0;	

if(Depth < 1) return qsearch(alpha,beta, 0); 

//nodos++;


if(Ply >= MAX_PLY){
	 return qsearch(alpha,beta, 0); 
}

if(repeticion()>0 || fifty >= 100){	   
	 return 0;
}

//** Mate distance pruning

alpha = Max(val_matado_en(Profundidad), alpha);
beta  = Min(val_mate_en(Profundidad+1), beta);
if (alpha >= beta) return alpha;


//Comprobamos si aun queda tiempo
if (!(nodos & 0x1FFF)) {//8.192 nodos
	if(tenemos_que_parar()){
		stop_search = true;
		return beta;
	} 		  
 }// nodos


//comprobamos las tablas hash	
#ifdef USAHASH
	
valorhash = probar_hash(&htipo, alpha, beta, Depth,&hashmov);
	if (Profundidad && htipo != HASH_DESCONOCIDO) {
	//if (!nodo_pv && Profundidad && htipo != HASH_DESCONOCIDO) {
	switch (htipo) {

		case HASH_EXACT:
		if(valorhash > alpha && valorhash < beta)
			 return valorhash;
		 break;

		case HASH_ALPHA:
		if (valorhash <= alpha)
			return valorhash;
		if(valorhash < beta ) {
				hacer_nulo = 0;
				beta = valorhash;
		}
		break;

		case HASH_BETA:
		if (valorhash >= beta) 
			return valorhash;	
		if(valorhash > alpha) alpha = valorhash;
		break;
		
		default:
		break;
		}
	}
	
#endif 


//** Comprobamos si estamos en jaque
if(check == desconocido){
 if(Color == BLANCAS)
	  EnJaque = casilla_atacada(Pos_RB,NEGRAS);
 else EnJaque = casilla_atacada(Pos_RN,BLANCAS);
} 
else  EnJaque = check;


BestEval = -VALMATE;

if(EnJaque) eval = 0;
  else eval = evalua_posicion(alpha,beta);


	//***  RAZORING STOCK *****
	if(  Depth < 4  
		&& hashmov.origen == 0
		&& EnJaque == false  
        && !nodo_pv
		&& FichasBB > 0 && FichasNN > 0
		&& !valor_es_mate(beta) 
	    && eval < beta - (0x200 + 0x10 * (Depth)) 
		&& !es_peon7(historial[hply-1].destino)
		) {
		int beta_reducido = beta - (0x200 + 0x10 * (Depth));
		int valor = qsearch(alpha, beta,0);	
		if (valor < beta_reducido) return valor;
	}

	//***  MOVIMIENTO NULO ESTATICO *****
	if(  Depth < 4  
		&& hacer_nulo
		&& EnJaque == false  
        && !nodo_pv
		&& FichasBB > 3 && FichasNN >3
		&& !valor_es_mate(beta) 		) { 
	
       if(eval >= beta +(0x100 + (0x32 * Depth)))
		return eval - (0x100 + (0x32 * Depth));
	}

#ifdef HACER_NULO
	  
    //** En ajedrez esta prohibido pasar, pero con esta tecnica se hace
	//** una simulacion, que consiste en dejar que el contrario juegue 2
	//** veces seguidas y si no consigue nada ventajoso, quiere decir 
	//** que nuestra posicion es tan buena que podemos dejar de analizar.
	//** Aunque tiene el problema del "zugzwang", palabra alemana para
	//** referirse a una posicion en la que interesa que juegue el con -
	//** trario, y al darle el turno otra vez al contrario, con el MN,
	//** ahora nuestra posicion nos parece mejor de lo que es en realidad.
	//** Afortunadamente estos casos se dan con poca frecuencia y cuando
	//** queda poco material. Esta totalmente prohibido hacer el MN 2 veces
	//** seguidas o cuando estamos en jaque, ademas de otras condiciones.
	
	  if ( hacer_nulo  
		  && (Depth > 1)
          && !nodo_pv
          && EnJaque == false 
          && FichasBB > 0 
		  && FichasNN > 0
		  && !valor_es_mate(beta) 
		  && eval >= beta) {

nul_probado++;
Valpaso = Alpaso;
Vhply = hply;
Alpaso = 0;
Color = -Color;
fifty++;
Vhash = hash;
hash ^= 0xDEADBEEF;

R = 3 + (Depth >  7 && FichasBB > 1  && FichasNN > 1 )
	  + (Depth > 11 && FichasBB > 2  && FichasNN > 2 );
//if(eval >= beta + 100 && Depth > 6 &&
  // FichasBB > 3  && FichasNN > 3) R++;



 if(Depth-R <= 0)
 nmscore = -qsearch(-beta,-alpha,0);
 else
 nmscore = -search(-beta,-alpha,Depth-R,false,EnJaque);
 
//* Restauramos los valores  
hash = Vhash;
fifty--;
hply = Vhply;
Color = -Color; 
Alpaso = Valpaso;


if(nmscore >= beta){
	nul_exito++;
		
	if (Depth <= 6) return nmscore; 
    // Parece que no es aconsejable aceptar un mate
	// proveniente del movimiento nulo...??
	if (nmscore >= VALMATE-100) nmscore = beta;
	// verificacion del movimiento nulo para evitar 
    // problemas con el zugzwang
	v_nulo = search(alpha, beta,Depth-R,false,EnJaque);
	if (v_nulo >= beta) return nmscore;
	
}
else {// Para no reducir, cuando tenemos amenaza de mate
	if(nmscore < -VALMATE + 100)  
	amenaza_mate = true;	
}

}//hacer_nulo  	
#endif 


// Internal iterative deepening.
    if (Depth >= (nodo_pv ? 6 : 8)&&
	   (hashmov.origen == 0  && hashmov.destino == 0)){
			
      int d =(nodo_pv ? Depth - 2 : Depth / 2);
			eval = search(alpha, beta, d,false,EnJaque);
			bestmove.origen  = VarPrinc[Profundidad][Profundidad].origen;
			bestmove.destino = VarPrinc[Profundidad][Profundidad].destino;
    }


 genera_todo();

//*** Mientras tengamos movimientos en la pila, los vamos sacando por orden, (segun el
//*** eval que les dimos al almacenarlos), lo ejecutamos internamente, y comprobamos 
//*** que sea un movimiento legal, es decir que no deje a su Rey en jaque. 
    
	 mov_legales = 0;
	
    while((i = tomanextmov()) >= 0) {

     MakeMove(i);
	 if(!es_legal()) {
		retrocede(); 
		continue;
	 }
     mov_legales++;
	 nodos++;
if(Color == BLANCAS)	
	  jaque = casilla_atacada(Pos_RB,NEGRAS);
 else jaque = casilla_atacada(Pos_RN,BLANCAS);

 extendido = 0;
 
 
//** Los extensores son una poderosa arma para los programas de ajedrez, sin ellos
//** su juego desmerecera bastante, la idea es la siguiente: si acabamos de hacer
//** una jugada prometedora, en esta lnea en concreto nos extendemos un ply, es
//** decir miraremos una jugada ms que en las dems lneas y cuando terminemos de
//** analizar la variante, puede que gracias a los extensores hayamos visto 5  6
//** jugadas ms que en el resto de variantes. 

//** Extensor de jaque, este extensor es obligado
	 if(jaque == true)  extendido = 1;

//** Si no es jaque probamos, otros extensores, pero controlando la
//** profundidad, para que el (factor branch) es decir la relacion que 
//** existe entre lo que se tarda en completar un ply y el siguiente, 
//** no se aleje mucho de 2.

	  else if(Profundidad < (Ply +(Ply / 2)) ||
	         (nodo_pv && Profundidad < (Ply * 2))){
	
		/* if(amenaza_mate == true &&
		      Depth < 6) extendido = 1;*/

         // Extensor de recaptura, despues del extensor de jaque, para  
		 // muchos programadores, este es el segundo mas efectivo, 	 
		 // Realizamos este extensor cuando la recaptura tiene lugar
		 // en la misma casilla, y lo capturado son fichas (peones no) 
	     // de igual valor, Alfil y Caballo se consideran de igual valor
		  if(nodo_pv  &&
		    (historial[hply-1].capturada > P_B && 
		     historial[hply-2].capturada > P_B)&&
		    (historial[hply-1].destino == historial[hply-2].destino) &&
	        (ValFicha2[historial[hply-1].capturada] ==
		     ValFicha2[historial[hply-2].capturada])){
		  extendido = 1; 
	     }// recaptura

		 // Extensor de Peon 7
		 else if(FichasBB + FichasNN <= 6 &&
				abs(contenido[ListaMov[i].destino]) == P_B &&
			   (FILA[ListaMov[i].destino] == 7 ||
				FILA[ListaMov[i].destino] == 2)) {
			    extendido = 1;
			}//peon 7    
		
	     // Extensor de peon 6, en final y si en 7 no hay peon 
	     // contrario esperando
	 /*    else if(FichasBB + FichasNN <= 2){
		    if (contenido[historial[hply-1].destino] == P_B &&
			 FILA[historial[hply-1].destino] == 6 &&
			 contenido[historial[hply-1].destino +10] != P_N &&
		     contenido[historial[hply-1].destino + 9] != P_N &&
		     contenido[historial[hply-1].destino +11] != P_N) {
			 extendido = 1;
			 }//peon blanco  
	         else if (contenido[historial[hply-1].destino] == P_N &&
			 FILA[historial[hply-1].destino] == 3 &&
		     contenido[historial[hply-1].destino -10] != P_B &&
		     contenido[historial[hply-1].destino- 9] != P_B &&
		     contenido[historial[hply-1].destino -11] != P_B) {
			 extendido = 1;
			 }//peon negro
	     }//peon 6	*/

	 }// control de profundidad

//*** Entrando en un final de peones, si ya nos hemos extendidos
//*** nos extendemos un ply mas, en caso contrario 2 plys. Esto
//*** nos ayudar a decidir si nos interesa o no, entrar en un final
//*** de peones.

  if(FichasBB == 0 && FichasNN == 0 &&
	 historial[hply-1].capturada > P_B){
		   extendido = 2;
  }
 

 
//****** FUTILITY MOVE PRUNING ***********

//** Despues de hacer el movimiento 
 if(Depth < 4 && //was 6
	eval < beta &&
	!EnJaque &&
	!extendido &&
	!amenaza_mate &&
    !nodo_pv &&
	BestEval > -VALMATE+Profundidad &&
    FichasBB > 1 && FichasNN > 1 &&
	ListaMov[i].enroquetipo == NO_ENROQUE &&
    ListaMov[i].promocion == 0  && 
	ListaMov[i].cap_alpaso == 0 &&
	mov_legales >= 2+Depth &&
	ListaMov[i].capturada == 0 &&
	!avance_peligroso(ListaMov[i].destino) ){

		int futility =  eval + (Depth*128); 
			if(futility < beta){
				if(futility > BestEval)
					BestEval = futility;
					retrocede(); 
					continue;
			}	

}// futility

 

 //*** Intentamos hacer una reduccion de los movimientos menos prometedores, es lo
 //*** contrario de los extensores, para poder hacerlo se tienen que dar ciertas
 //*** condiciones, cuantas menos condiciones mas rapido, pero menos fiable.
  

	 //if(Var_Principal && mov_legales == 1 ) 	
     if(mov_legales == 1 ) //El primer movimiento sin reduccin	
          eval = -search(-beta,-alpha,Depth+extendido-1,true,jaque);
	 
	 else { //intentamos reducir

//LMR:	 Reduccion de los ultimos movimientos
if( Depth >= 2 && //was 2
	!amenaza_mate &&
    !extendido  && 
	!EnJaque &&	
	!nodo_pv && 
    FichasBB > 0 && FichasNN > 0 &&
	ListaMov[i].enroquetipo == NO_ENROQUE &&
    ListaMov[i].promocion == 0  && 
	ListaMov[i].cap_alpaso == 0 &&
	Eval_Last_Move < (max_good_mov *60/100) &&
    mov_legales >= 4 ){
	
	if( Depth >= 4 && //was > 4             
        mov_legales > 8 && 
		FichasBB > 2 && FichasNN > 2 && 
		!avance_peligroso(ListaMov[i].destino))

			eval = -search(-alpha-1,-alpha,Depth-3,true,jaque);
			else 
			eval = -search(-alpha-1,-alpha,Depth-2,true,jaque);
}
		 // Nos aseguramos de ver todas las jugadas
	   else eval = alpha +1;
		 if(eval > alpha){
            eval = -search(-alpha-1,-alpha,Depth+extendido-1,true,jaque);
            if(eval > alpha && eval < beta)
			//if(nodo_pv && eval > alpha && eval < beta)
            eval = -search(-beta,-alpha,Depth+extendido-1,true,jaque);
			}
	   }//else       
		 retrocede(); 

//** Si se nos acaba el tiempo, paramos de ver movimientos
   if (stop_search == true) break;
		
   if(eval > BestEval) {  
	 BestEval = eval; 

#ifdef USAHASH
     bestmove.origen = ListaMov[i].origen;
     bestmove.destino = ListaMov[i].destino;
#endif 

	 if(BestEval > alpha) {   
		 if(good_mov[contenido[ListaMov[i].destino]+7] 
		  [ListaMov[i].origen] [ListaMov[i].destino] + Depth/4 < 80000){

			good_mov[contenido[ListaMov[i].destino]+7] 
		    [ListaMov[i].origen] [ListaMov[i].destino] += Depth/4;

				if(good_mov[contenido[ListaMov[i].destino]+7] 
		           [ListaMov[i].origen] [ListaMov[i].destino] > max_good_mov)
				max_good_mov = good_mov[contenido[ListaMov[i].destino]+7] 
				   [ListaMov[i].origen] [ListaMov[i].destino];
	    }

        if(BestEval >= beta) {
	        
//*** Hemos encontrado una fuerte jugada, y la recordaremos como matekiller o
//*** como killer, por si nos la volvemos a encontrar en otra variante. La 
//*** ejecutaremos con prioridad, pues lo normal es que si una jugada es fuerte,
//*** en una posicion, lo siga siendo en otra combinacion de jugadas
			
			//** Si amenaza mate, la recordamos como matekiller
            if(BestEval > (VALMATE-100)){
                matekiller[Profundidad].origen =  ListaMov[i].origen;
				matekiller[Profundidad].destino = ListaMov[i].destino;
			}
			//** Si es un captura, o una promocion a Dama, no hace falta 
			//** recordarla, pues ya tienen una prioridad muy elevada;
			//** de lo contrario la guardamos como movimiento killer
			else 
			if(ListaMov[i].capturada == VACIO &&
			   ListaMov[i].promocion < D_B){
			killer2[Profundidad] = killer1[Profundidad];
			killer1[Profundidad].origen = ListaMov[i].origen;
			killer1[Profundidad].destino = ListaMov[i].destino;
			}

			
#ifdef USAHASH   
   store_hash(BestEval, alpha, beta, Depth,bestmove);
#endif 
			return BestEval;
			
		}//BestEval > beta

        ActVarPrincipal(i);
	    alpha = BestEval;           
		}//BestEval > alpha

      }//eval > Besteval
   }//while
if (stop_search == true) return beta;

   //** Si no hay movimientos legales,o son tablas o es mate.
   if(mov_legales == 0){
	   if(EnJaque== false) return 0;	
       else return -VALMATE+Profundidad+1;
	 }


#ifdef USAHASH   
   store_hash(BestEval, alpha, beta, Depth,bestmove);
#endif 
   return BestEval;

} //search

//* BUSCANDO TRANQUILIDAD, esta rutina es parte de la busqueda alfa/beta,
//* que con el tiempo se ha sofisticado,(no es nuestro caso) al extremo 
//* que necesita su propio espacio.

//* De hecho el programa visita mas veces esta rutina que search(); debido 
//* a que siempre le dedica la misma atencion, independientemente de que se
//* trate del ply 1 o del ply 20.

//* Que es lo que pretende ?, encontrar una posicion lo suficientemente
//* tranquila para que la evaluacion sea fiable. El bando al que le toca
//* mover, puede decidir, dejarlo como esta, si la posicion es aceptable
//* (evaluacion >= beta), o seguir capturando hasta conseguir otra posicion
//* mas favorable.

//* Como lo hace ?, generando solo las capturas (y promocion a Dama en
//* algunos casos); las capturas hay que ordenarlas siguiendo el sistema
//* MVV/LVA, capturar la pieza mas valiosa, con la de menos valor, pero
//* dando prioridad a la capturada, es decir DxD tiene prioridad sobre PxT;
//* esto no quiere decir que sea mejor captura, que no lo es, pero el 
//* beneficio que se obtiene es grande, ya que las ramas del arbol que hay
//* que analizar se reducen drasticamente, conforme desparecen del tablero
//* las piezas pesadas.

//* Tenemos que decidir, si comprobamos los jaques o no, algunos programadores
//* lo hacen y otros no; los que lo hacen, que son mayoria, utilizan un
//* generador de movimiento especial llamado evasion de jaques, que solo 
//* genera los movimientos que neutralizan el jaque.
//* En esta version se utiliza un sistema intermedio, se comprueban los jaques
//* pero solo para no podar. Tambien utilizamos el evaluador estatico de 
//* intercambios de fichas see(), para podar las malas capturas reales, se 
//* puede perder algo, pero raramente este tipo de captura mejora el 
//* rendimiento global.

int qsearch(int alpha,int beta,int Depth)
{
	int i;
    int eval;
	bool final;
	int jaque;

   // qnodos++;

//Comprobamos si aun queda tiempo
if (!(nodos & 0x1FFF)) {//cada 8.192 nodos
    if(tenemos_que_parar()){
		stop_search = true;
		return beta;
	} 		  
 }// nodos


 eval = evalua_posicion(alpha,beta);

 if(Color == BLANCAS)
	  jaque = casilla_atacada(Pos_RB,NEGRAS);
 else jaque = casilla_atacada(Pos_RN,BLANCAS);

 //** No queremos eternizarnos aqui abajo, no se si es correcto
 //** pero he visto que algunos motores punteros lo hacen. ?
 if(!jaque && Depth < -6) return  eval;

 if(!jaque && eval >= beta) return eval; 
 if(eval > alpha) alpha = eval;

 VarPrinc[Profundidad][Profundidad].origen = 0;
 genera_capturas();
	 
	if (FichasBB > 1 && FichasNN > 1 &&
		PeonesBB > 1 && PeonesNN > 1){
		final = false;
	}	
	else final = true;

	while((i=tomanextmov())>=0) {
		//* Miramos si se reunen los requisitos necesarios, para
		//* no hacer esta captura
		if(!jaque && !final && ListaMov[i].promocion == 0){
			//* Modo see(3)b 
			if (eval + 150 + ValFicha[ListaMov[i].capturada] < alpha ||
				 (ValFicha2[abs(contenido[ListaMov[i].origen])]-250 >
				 ValFicha2[abs(contenido[ListaMov[i].destino])] &&
				 see(ListaMov[i].origen,ListaMov[i].destino) < 0))
				
				 continue;
		}
		
     MakeMove(i);
	 if(!es_legal()) {
         retrocede(); 
         continue;
	 }
qnodos++;
// legales++;
// Si estamos en Jaque, nos extendemos un ply
 eval = -qsearch(-beta,-alpha,Depth-1+jaque);
 retrocede();

 if(eval >= beta) return beta;  
 if(eval > alpha) {
	alpha = eval;
	ActVarPrincipal(i);	
 }	
} //while
 
return alpha; 
}

bool es_peon7(int destino){
	if (contenido[destino] == P_B){ 
		if(FILA[destino] == 7) 
		return true;
	}
	if (contenido[destino] == P_N){ 
		if(FILA[destino] == 2) 
		return true;
	}
	return false;
}

//* Para no podar o hacer LMR, si la jugada es un avance
//* de peon peligroso.
//* Tal cual esta, es para utilizar despues de hacer el movimiento.

bool avance_peligroso(int destino){

if (contenido[destino] == P_B){ 
	if(FILA[destino] == 7) 
		return true;
	else if(FILA[destino] == 6 &&
	    contenido[destino +10] != P_N &&
		contenido[destino + 9] != P_N &&
		contenido[destino +11] != P_N)
		return true;

}
if (contenido[destino] == P_N){ 
	if(FILA[destino] == 2) 
		return true;
	else if(FILA[destino] == 3 &&
	    contenido[destino -10] != P_B &&
		contenido[destino - 9] != P_B &&
		contenido[destino -11] != P_B)
		return true;

}
return false;
}
/*
// Para usar antes de hacer el movimiento
bool avance_peligroso2(int origen, int destino){

if (contenido[origen] == P_B){ 
	if(FILA[destino] == 7) 
		return true;
	else if(FILA[destino] == 6 &&
	    contenido[destino +10] != P_N &&
		contenido[destino + 9] != P_N &&
		contenido[destino +11] != P_N)
		return true;
	
}
if (contenido[origen] == P_N){ 
	if(FILA[destino] == 2) 
		return true;
	else if(FILA[destino] == 3 &&
	    contenido[destino -10] != P_B &&
		contenido[destino - 9] != P_B &&
		contenido[destino -11] != P_B)
		return true;

}
return false;
}

//contenido[historial[hply-1].destino +10]
bool mov_conectado() {
int origen_1 = historial[hply-3].origen;
int destino_1 = historial[hply-3].destino;
int origen_2 = historial[hply-1].origen;
int destino_2 = historial[hply-1].destino;
// se mueve la misma ficha
if(origen_2 == destino_1) return true;
// el destino del mov 2, lo dejo vacante el 1
if(destino_2 == origen_1) return true;
return false;

}
*/
bool tenemos_que_parar() {

// Se nos acaba el tiempo ?
if(GetTime() >= stop_time ){ 
	 if(en_tiempo_contrario == true ){
		if(GetTime() >= (stop_time + (maxtiempo*2)) )
			return true;
	 }
	 else {
		if(Var_Principal || quedan <= 4)			     
			return true;
		else if(GetTime() >= (stop_time + maxtiempo) ) 
			return true;
	 }

}//(GetTime

// Nos llega un comando de WinBoard ?				
if(wboard && CheckInput()){
	if(en_tiempo_contrario == true ) return true;
		else {
		char linea[256], comando[256];
		fgets(linea, 256, stdin);
		sscanf(linea, "%s", comando);
			if (strcmp(comando, "exit") == 0 ||
				strcmp(comando, "?") == 0 ){ 
				return true;
			}	 				 
		}
}//winboard

// Nos llega un comando en modo consola ?
if (!wboard && _kbhit()) {
    return true;;
		}
	return false;
}// tenemos


//* Esta rutina, nos permitira, saber si al hacer un movimiento,
//* damos jaque, sin necesidad de hacer el movimiento realmente.
//* La idea es utilizarla en futility move pruning, antes de
//* hacer el movimiento, se supone que sera mas rapido.
/*
bool Da_jaque(int origen, int destino){

int cont_origen;
int cont_destino;

//* Movemos la ficha, y guardamos la posicion 
//* original para restablecerla
cont_origen = contenido[origen];
contenido[origen] = VACIO;
cont_destino = contenido[destino];
contenido[destino] = cont_origen;

//* Miramos si se da jaque, 
if(cont_origen > 0){
	if(casilla_atacada(Pos_RN,BLANCAS)){
       contenido[origen] = cont_origen;
       contenido[destino] = cont_destino;
       return true;
	}
}

else if(casilla_atacada(Pos_RB,NEGRAS)){
		contenido[origen] = cont_origen;
		contenido[destino] = cont_destino;
		return true;
}


contenido[origen] = cont_origen;
contenido[destino] = cont_destino;
return false;

}
*/